// -*-C++-*-
// coordsystem.cpp (imported from forge/servers/pangea/MapLaw/MapCoordSystem.cc)
//
//  The WorldForge Project
//  Copyright (C) 2000  The WorldForge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about WorldForge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//

#include "coordsystem.h"

CoalCoordSystem::CoalCoordSystem ()
{
  // Set sane defaults
  SetExtents(100, 100, 100);
  SetGrain(1, 1, 1);
}

CoalCoordSystem::~CoalCoordSystem()
{
}

void CoalCoordSystem::SetExtents (CoalCoordType x, CoalCoordType y, CoalCoordType z)
{
  SetXExtents(x);
  SetYExtents(y);
  SetZExtents(z);
}

void CoalCoordSystem::SetGrain (CoalCoordType x, CoalCoordType y, CoalCoordType z)
{
  SetXGrain(x);
  SetYGrain(y);
  SetZGrain(z);
}

// Check to see if point is inside the valid coordinate system
bool CoalCoordSystem::IsPointValid(CoalCoord& testPoint)
{
  bool bValidX = (testPoint.GetX() >= 0) &&
    (testPoint.GetX() <= GetXExtents());

  bool bValidY = (testPoint.GetY() >= 0) &&
    (testPoint.GetY() <= GetYExtents());

  bool bValidZ = (testPoint.GetZ() >= 0) &&
    (testPoint.GetZ() <= GetZExtents());

  return (bValidX && bValidY && bValidZ);
}
