// -*-C++-*-
// isoloader.h
//
//  The WorldForge Project
//  Copyright (C) 2000  The WorldForge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about WorldForge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//

#ifndef __ISOLOADER_H
#define __ISOLOADER_H

#include "maploader.h"

// This loader is for parsing the original UClient flatfile maps.

class CoalIsoLoader : public CoalMapLoader
{
public:
    CoalIsoLoader (CoalDatabase &db) : CoalMapLoader (db) {}
    virtual ~CoalIsoLoader () {}

    virtual bool LoadMap (const char *mapfile);
    virtual bool LoadMap (const char *mapbuffer, int buffersize);
    virtual bool SaveMap (const char *mapfile, int save_flags = 0,
                          CoalShape *partial_map = NULL);
    virtual bool CleanupLoader () { return false; }
};

#endif  // __ISOLOADER_H
