// -*-C++-*-
// object.h
//
//  The WorldForge Project
//  Copyright (C) 2000  The WorldForge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about WorldForge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//

// Generic container for a single object image.

#ifndef __OBJECT_H
#define __OBJECT_H

#include <stl.h>
#include <string>

#include "graphic.h"
#include "coord.h"

class CoalObject
{
public:
    CoalObject () { Init (); }
    virtual ~CoalObject () {}

    void Init () { graphic = NULL; xdata = NULL; }
public:
    CoalGraphic *graphic;
    CoalCoord anchor;

    string name;  // Short name of object
    string desc;  // Type of object (good for queries)
    CoalColor color; // Color for bird's eye radar maps
    void *xdata;  // Extra field for misc data (used by loaders)
};

typedef vector<CoalObject*> CoalObjectArray;

#endif  // __OBJECT_H
