// -*-C++-*-
// query.cpp
//
//  The WorldForge Project
//  Copyright (C) 2000  The WorldForge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about WorldForge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//

#include <stdio.h>  // DELETEME: just here for FIXME messages
#include "query.h"

////////// CoalQueryData //////////

CoalQueryDataType CoalQueryData::GetItem (int index)
{
    if (index < 0 || index >= GetCount ())
	return NULL;

    return m_data[index];
}

void CoalQueryData::AppendItem (CoalQueryDataType item)
{
    m_data.push_back (item);
}

void CoalQueryData::RemoveItem (int index, CoalQueryDataType item)
{
    if (index < 0 || index >= GetCount ())
	return;

    vector<CoalQueryDataType>::iterator pos;
    pos = m_data.begin () + index;
    m_data.erase (pos);
}

////////// CoalQuery //////////

bool CoalQuery::QueryAll ()
{
    m_query = m_extents;
    return true;
}

bool CoalQuery::QueryBefore (int bound)
{
    if (!m_extents.IsInRange (bound))
	return false;

    m_query.SetRange (m_extents.GetStart(), bound);
    return true;
}

bool CoalQuery::QueryAfter (int bound)
{
    if (!m_extents.IsInRange (bound))
	return false;

    m_query.SetRange (bound, m_extents.GetEnd());
    return true;
}

bool CoalQuery::QueryBetween (int bound1, int bound2)
{
    if (!m_extents.IsInRange (bound1) || !m_extents.IsInRange (bound2))
	return false;

    m_query.SetRange (bound1, bound2);
    return true;
}

bool CoalQuery::QueryBetween (CoalRange &range)
{
    return QueryBetween (range.GetStart(), range.GetEnd ());
}

void CoalQuery::GetQueryParameters (QueryParameter &param)
{
    // FIXME: Should be more complex
    //param = m_extents;
    printf ("*** FIXME: CoalQuery::GetQueryParameters() not implemented!\n");
}

