// -*-C++-*-
// region.h
//
//  The WorldForge Project
//  Copyright (C) 2000  The WorldForge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about WorldForge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//

#ifndef __REGION_H
#define __REGION_H

#include "shape.h"
#include "graphic.h"

/*
 * CIRCLE: m_coords[0] holds the center; m_radius is radius
 * SQUARE/RECT: m_coords[0] is topleft coord; m_coords[1] is bottomright
 * POLYGON: m_coords is the array of polygonal points
 */

class CoalFill
{
public:
    CoalFill () { graphic = NULL; }
    virtual ~CoalFill () {}

public:
    string name;
    CoalPolyGraphic *graphic;

    // Will later contain algorithms for determining the distribution
    // of the various graphics in CoalPolyGraphic.
};

// A shape associated with graphics and a layer level
class CoalRegion : public CoalShape
{
public:
    CoalRegion ()
        { m_layer = 0; m_fill = NULL; }
    //CoalRegion (CoalRegionType rtype, CoalCoord coord1, ...);

    virtual ~CoalRegion () {}

    void SetFill (CoalFill *fill) { m_fill = fill; }
    CoalFill* GetFill () { return m_fill; }
    void SetLayer (int layer) { m_layer = layer; }
    int GetLayer () { return m_layer; }

public:
    string name;

private:
    CoalFill *m_fill;
    int m_layer;
};

typedef vector<CoalFill*> CoalFillArray;
typedef vector<CoalRegion*> CoalRegionArray;

#endif  // __REGION_H
