// -*-C++-*-
// testblade.cpp
//
//  The WorldForge Project
//  Copyright (C) 2000  The WorldForge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about WorldForge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//

#include <stdio.h>

#include "debug.h"
#include "bladeloader.h"

int main (int argc, char *argv[])
{
    int ret = 0;

    const char *loadfile = "blade3.xml";
    const char *savefile = "blade-testsave.xml";

    CoalDatabase database;

    CoalBladeLoader loader (database);
    if (!loader.LoadMap (loadfile))
    {
        // Broke the test, but may as well continue...
        ret = -1;
        printf ("\n******** ERROR ********\n**\n** FAILED TO LOAD MAP!!\n**\n");
        printf ("***********************\n\n");
    }

    printf ("======== Dumping database ========\n\n");

    CoalDebug debug;
    debug.Dump (database);

    printf ("======== Saving Blade map to %s ========\n\n", savefile);
    if (!loader.SaveMap (savefile, COAL_SAVE_ALL))
    {
        // Broke the test, but may as well continue...
        ret = -1;
        printf ("\n******** ERROR ********\n**\n** FAILED TO SAVE MAP!!\n**\n");
        printf ("***********************\n\n");
    }

    return (ret);
}
