// -*-C++-*-
// testcoal.cpp
//
//  The WorldForge Project
//  Copyright (C) 2000  The WorldForge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about WorldForge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//

#include <stdio.h>

#include "coord.h"
#include "debug.h"

const int NUM_COORDS = 5;

int main (int argc, char *argv[])
{
    printf ("Testing COAL...\n");

    CoalDebug debug;  // Debug to stdout
    CoalCoord coords[NUM_COORDS];

    for (int i = 0; i < NUM_COORDS; i++)
    {
	coords[i].SetCoord ((i + 1), (i + 1) * 2, (i + 1) * 3);
	debug.Dump (coords[i]);
    }

    printf ("Testing CoalCoord::GetDistanceTo()...\n");
    CoalCoord distcoord1 (10, 10, 0);
    CoalCoord distcoord2 (20, 5, 0);
    printf ("  dx = %f\n  dy = %f\n  distance = %f (should be 11.180340)\n",
            distcoord2.GetX () - distcoord1.GetX (), 
            distcoord2.GetY () - distcoord1.GetY (),
            distcoord1.GetDistanceTo (distcoord2));

#if 0  // FIXME: Broken until CoalMapLoader is working
    CoalGraphic graphic1 ("grafx1.png");
    CoalGraphic graphic2 ("grafx2.png");
    CoalGraphic graphic3 ("grafx3.png");
    CoalGraphic graphic4 ("grafx4.png");
    CoalGraphic graphic5 ("grafx5.png");

    CoalMap map (100.0, 100.0, 10.0);
    map.AddGraphic (&graphic1);
    map.AddGraphic (&graphic2);
    map.AddGraphic (&graphic3);
    map.AddGraphic (&graphic4);
    map.AddGraphic (&graphic5);

    printf ("====DUMPING MAP====\n");
    printf ("Found %d graphics\n", map.GetGraphicCount ());
    debug.Dump (map);

    printf ("====DUMPING MAP AFTER MOVE====\n");
    CoalGraphic *gfx;
    gfx = map.GetGraphicAt (coords[1]);
    if (gfx)
    {
	GID gid;
	CoalCoord findcoord = CoalCoord (10, 0, 0);

	gid = gfx->id;
	map.MoveGraphic (gid, findcoord);
	debug.Dump (map, COAL_DEBUG_BRIEF);
    }
#endif
}
